/**
  *  \file int/builtin.h
  *  \brief Interpreter: Code Generation for Builtin Functions
  *
  *  (c) 2001-2022 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_INT_BUILTIN_H
#define PCC_V2_INT_BUILTIN_H

#include "cpluslib/string.h"

class IntFunctionCallNode;

/** Description of a builtin function. */
struct TBuiltinFunctionDescriptor {
    /// Name of the function.
    const char* name;

    /// Argument count restrictions.
    int min_args, max_args;

    /// Node generator function.
    IntFunctionCallNode* (*generator)(const TBuiltinFunctionDescriptor& desc);

    /// Additional parameter for node generator.
    int generator_arg;
};

const TBuiltinFunctionDescriptor* lookupBuiltinFunction(string_t name);

#endif
