/**
  *  \file u/t_arch_platform.cc
  *
  *  (c) 2001-2022 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "arch/platform.h"

#include "u/t_arch.h"
#include "io/dirs.h"
#include "cpluslib/string.h"

void
ArchPlatformTestSuite::testPlatformDirs()
{
    string_t ddir = Platform::getDataDirectory();
    string_t rdir = Platform::getResourceDirectory();
    string_t s0dir = Platform::getUserSettingsDirectory(0);
    string_t s1dir = Platform::getUserSettingsDirectory(1);

    TS_ASSERT_DIFFERS(ddir.size(), 0U);
    TS_ASSERT_DIFFERS(rdir.size(), 0U);
    TS_ASSERT_DIFFERS(s0dir.size(), 0U);
    TS_ASSERT_DIFFERS(s1dir.size(), 0U);

    TS_ASSERT(Directory::isAbsoluteName(ddir));
    TS_ASSERT(Directory::isAbsoluteName(rdir));
    TS_ASSERT(Directory::isAbsoluteName(s0dir));
    TS_ASSERT(Directory::isAbsoluteName(s1dir));
}
